<template>
    <div class="edit-view">
        <page-title>
            <el-button @click="$router.go(-1)" :disabled="saving">取消</el-button>
            <el-button @click="onDelete" :disabled="saving" type="danger" v-if="formData.id">
                删除
            </el-button>
            <el-button @click="onSave" :loading="saving" type="primary">保存</el-button>
        </page-title>
        <div class="edit-view__content-wrapper">
            <div class="edit-view__content-section">
                <el-form
                    :model="formData"
                    :rules="rules"
                    ref="form"
                    label-width="94px"
                    label-position="right"
                    size="small"
                    style="max-width: 700px;"
                >
                    <el-form-item prop="navigationId" label="栏目">
                        <el-cascader
                            style="width: 100%"
                            v-model="formData.navigationId"
                            :props="optionProps"
                            :options="navigationIdOptions"
                            :show-all-levels="false"
                            placeholder="请选择栏目"
                        >
                        </el-cascader>
                    </el-form-item>
                    <el-form-item prop="icon" label="图标">
                        <single-upload v-model="formData.icon"></single-upload>
                    </el-form-item>
                    <el-form-item prop="title" label="标题">
                        <el-input v-model="formData.title"></el-input>
                    </el-form-item>
                    <el-form-item prop="content" label="内容">
                        <el-input type="textarea" :rows="10" v-model="formData.content"></el-input>
                    </el-form-item>
                </el-form>
            </div>
        </div>
    </div>
</template>
<script>
export default {
    name: 'DetailEdit',
    created() {
        if (this.$route.query.id) {
            this.$http
                .get('serviceDetail/get/' + this.$route.query.id)
                .then(res => {
                    this.formData = res;
                })
                .catch(e => {
                    console.log(e);
                    this.$message.error(e.error);
                });
        }
        this.$http
            .post('/navigation/type', { type: 'AGENT' })
            .then(res => {
                if (res.length > 0) {
                    // res.forEach(item => {
                    //     this.navigationIdOptions.push({
                    //         label: item.name,
                    //         value: item.id
                    //     });
                    // });
                    this.navigationIdOptions = this.delChild(res);
                }
            })
            .catch(e => {
                console.log(e);
                this.$message.error(e.error);
            });
    },
    data() {
        return {
            saving: false,
            formData: {},
            rules: {},
            navigationIdOptions: [],
            optionProps: {
                value: 'id',
                label: 'name',
                children: 'children',
                multiple: false,
                emitPath: false,
                checkStrictly: false,
                expandTrigger: 'hover'
            }
        };
    },
    methods: {
        onSave() {
            this.$refs.form.validate(valid => {
                if (valid) {
                    this.submit();
                } else {
                    return false;
                }
            });
        },
        submit() {
            let data = { ...this.formData };

            this.saving = true;
            this.$http
                .post('/serviceDetail/save', data, { body: 'json' })
                .then(res => {
                    this.saving = false;
                    this.$message.success('成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    console.log(e);
                    this.saving = false;
                    this.$message.error(e.error);
                });
        },
        onDelete() {
            this.$alert('删除将无法恢复，确认要删除么？', '警告', { type: 'error' })
                .then(() => {
                    return this.$http.post(`/serviceDetail/del/${this.formData.id}`);
                })
                .then(() => {
                    this.$message.success('删除成功');
                    this.$router.go(-1);
                })
                .catch(e => {
                    if (e !== 'cancel') {
                        console.log(e);
                        this.$message.error((e || {}).error || '删除失败');
                    }
                });
        },
        delChild(list) {
            return list.map(item => {
                const info = {
                    ...item,
                    ['children']:
                        item['children'] && item['children'].length > 0 ? this.delChild(item['children']) : null
                };
                return info;
            });
        }
    }
};
</script>
<style lang="less" scoped></style>
